Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.gradle.api
Interface DomainObjectCollection

    interface DomainObjectCollection
    extends java.lang.Iterable

A `DomainObjectCollection` represents a read-only set of domain objects of type `T`.

The object in a collection are accessable as read-only properties of the collection, using the name of the object as the property name. For example:

     tasks.add('myTask')
     tasks.myTask.dependsOn someOtherTask

A dynamic method is added for each object which takes a configuration closure. This is equivalent to calling #getByName(String, groovy.lang.Closure). For example:

     tasks.add('myTask')
     tasks.myTask {
         dependsOn someOtherTask
     }

You can also use the `[]` operator to access the objects of a collection by name. For example:

     tasks.add('myTask')
     tasks['myTask'].dependsOn someOtherTask

param:
  The type of domain objects in this collection.

Method Summary
`void` | `allObjects(Action action)` Executes the given action against all objects in this collection, and any objects subsequently added to this collection.
`void` | `allObjects(Closure action)` Executes the given closure against all objects in this collection, and any objects subsequently added to this collection.
`Set` | `findAll(Spec spec)` Returns the objects in this collection which meet the given specification.
`T` | `findByName(java.lang.String name)` Locates an object by name, returning null if there is no such object.
`Set` | `getAll()` Returns the objects in this collection.
`Map` | `getAsMap()` Returns the objects in this collection, as a map from object name to object instance.
`T` | `getAt(java.lang.String name)` Locates an object by name, failing if there is no such task.
`T` | `getByName(java.lang.String name)` Locates an object by name, failing if there is no such object.
`T` | `getByName(java.lang.String name, Closure configureClosure)` Locates an object by name, failing if there is no such object.
`DomainObjectCollection` | `matching(Spec spec)` Returns a collection which contains the objects in this collection which meet the given specification.
`Action` | `whenObjectAdded(Action action)` Adds an {
`void` | `whenObjectAdded(Closure action)` Adds a closure to be called when an object is added to this collection.
`Action` | `whenObjectRemoved(Action action)` Adds an {
`DomainObjectCollection` | `withType(java.lang.Class type)` Returns a collection containing the objects in this collection of the given type.

Methods inherited from interface java.lang.Iterable
iterator

Methods inherited from class java.lang.Object
hashCode, getClass, equals, toString, wait, wait, wait, notify, notifyAll

Method Detail

### allObjects

    public void allObjects(Action action)

  Executes the given action against all objects in this collection, and any objects subsequently added to this collection.
  param:
    action The action to be executed

### allObjects

    public void allObjects(Closure action)

  Executes the given closure against all objects in this collection, and any objects subsequently added to this collection.
  param:
    action The closure to be called

### findAll

    public Set findAll(Spec spec)

  Returns the objects in this collection which meet the given specification.
  param:
    spec The specification to use.
  return:
    The matching objects. Returns an empty set if there are no such objects in this collection.

### findByName

    public T findByName(java.lang.String name)

  Locates an object by name, returning null if there is no such object.
  param:
    name The object name
  return:
    The object with the given name, or null if there is no such object in this collection.

### getAll

    public Set getAll()

  Returns the objects in this collection.
  return:
    The objects. Returns an empty set if this collection is empty.

### getAsMap

    public Map getAsMap()

  Returns the objects in this collection, as a map from object name to object instance.
  return:
    The objects. Returns an empty map if this collection is empty.

### getAt

    public T getAt(java.lang.String name)

  Locates an object by name, failing if there is no such task. This method is identical to #getByName(String). You can call this method in your build script by using the groovy `[]` operator.
  param:
    name The object name
  return:
    The object with the given name. Never returns null.
  throws:
    UnknownDomainObjectException when there is no such object in this collection.

### getByName

    public T getByName(java.lang.String name)

  Locates an object by name, failing if there is no such object.
  param:
    name The object name
  return:
    The object with the given name. Never returns null.
  throws:
    UnknownDomainObjectException when there is no such object in this collection.

### getByName

    public T getByName(java.lang.String name, Closure configureClosure)

  Locates an object by name, failing if there is no such object. The given configure closure is executed against the object before it is returned from this method. The object is passed to the closure as it's delegate.
  param:
    name The object name
  param:
    configureClosure The closure to use to configure the object.
  return:
    The object with the given name, after the configure closure has been applied to it. Never returns null.
  throws:
    UnknownDomainObjectException when there is no such object in this collection.

### matching

    public DomainObjectCollection matching(Spec spec)

  Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.
  param:
    spec The specification to use.
  return:
    The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

### whenObjectAdded

    public Action whenObjectAdded(Action action)

  Adds an `Action` to be executed when an object is added to this collection.
  param:
    action The action to be executed
  return:
    the supplied action

### whenObjectAdded

    public void whenObjectAdded(Closure action)

  Adds a closure to be called when an object is added to this collection. The newly added object is passed to the closure as the parameter.
  param:
    action The closure to be called

### whenObjectRemoved

    public Action whenObjectRemoved(Action action)

  Adds an `Action` to be executed when an object is removed from this collection.
  param:
    action The action to be executed
  return:
    the supplied action

### withType

    public DomainObjectCollection withType(java.lang.Class type)

  Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.
  param:
    type The type of objects to find.
  return:
    The matching objects. Returns an empty set if there are no such objects in this collection.

Groovy Documentation